#ifndef __EULERANGLES_H
#define __EULERANGLES_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "config.h"
#include "matrixTCL.h"

class ORBITDYN_API CEulerException : public BaseException
{
public:
	CEulerException(const std::string& details = "") 
		: BaseException("CEuler exception:",details)
	{
	}
	virtual ~CEulerException()
	{
	}
	CEulerException(const CEulerException& cdte)
		:BaseException(cdte)
	{
	}
};

/*!ŷ
*/
class ORBITDYN_API CEuler
{
public:
	//! ŷת
	unsigned int seq;
	//! ŷ
	double phi,theta,psi;

	CEuler();
	CEuler(const unsigned int s,double a,double b,double c);
	CEuler(double*);
	~CEuler();
	
	// ̬̬
	void SetValueFromMatrix312(const Matrix& m);
	void SetValueFromMatrix123(const Matrix& m);
	void SetValueFromMatrix231(const Matrix& m);
	void SetValue(double a,double b,double c);

	//! תĶ
	Matrix ToMatrix();
	
	//! СǶµ̬
	Matrix SmallAngleMatrix();

	double operator[](const int i) const{
		if(i==0)
			return phi;
		else if(i==1)
			return theta;
		else if(i==2)
			return psi;
		else
			throw CEulerException("index error");
	}

	double& operator[](const int i){
		if(i==0)
			return phi;
		else if(i==1)
			return theta;
		else if(i==2)
			return psi;
		else
			throw CEulerException("index error");
	}
};

ORBITDYN_API std::ostream & operator <<(std::ostream & os, const CEuler& euler);

#endif // __EULERANGLES_H
