/*!
\file  Facility.cpp
\author HanDle
վϵλ
*/

#ifndef __FACILITY_H
#define __FACILITY_H

#include "Coordination.h"
#include "Utility.h"

/*!վ
*/
class ORBITDYN_API CFacility
{
public:
	//! С
	double Elevation;

	//! 
	double Longitude,Latitude,Altitude;

	//! عϵλ
	Vector ECFPosition;

	//! ĬϹ캯
	CFacility()
		:Elevation(0.08726646),Longitude(116.388),Latitude(39.9),Altitude(0.2)
	{
		CalculateECF();
	}

	//! γȹ캯
	CFacility(double lon,double lat,double alt,double elev = 5.0);

	//! 
	~CFacility(){ }

	//! þγ
	void SetGeodetic(double Longitude,double Latitude,double Altitude);

	//! ϵλٶ
	void GetECI(const CDateTime time,Vector & Position,Vector & Velocity);

	//! J2000.0ϵλ
	Vector ECIPos(const CDateTime time);

private:

	//! ϵλٶ
	void CalculateECI(CDateTime time);

	//! عϵλ
	void CalculateECF();
};

#endif  // __FACILITY_H
