/*!
\file  Facility.cpp
\author HanDle
վĺ
*/

#include "Facility.h"

/*!
캯
Longitude,Latitude,Altitude:()γ()߶(km)
*/
CFacility::CFacility(double Lon,double Lat,double Alt,double elev /* = 5 */)
{
	Elevation = elev*RAD;
	Longitude = Lon*RAD;
	Latitude = Lat*RAD;
	Altitude = Alt;
	CalculateECF();
}
/*!
õ
lon,lat,alt:()γ()߶(km)
*/
void CFacility::SetGeodetic(double Lon,double Lat,double Alt)
{
	Longitude = Lon*RAD;
	Latitude = Lat*RAD;
	Altitude = Alt;
	CalculateECF();
}
/*!
վJ2000ϵλúٶ
time:ʱ
pos,vel:λúٶ
*/
void CFacility::GetECI(const CDateTime time,Vector & pos,Vector & vel)
{
	Vector r = ~(PolarMotion(time))*ECFPosition; // ׼عϵλ
	Vector w(0,0,We);
	Vector v = Cross(w,r); // ת׼عϵٶ
	Matrix PN = ~(Precession(time))*~(Nutation(time))*~(EarthRotation(time));
	pos = PN*r;
	vel = PN*v;
}

/*!
վJ2000ϵλúٶ
time:ʱ
*/
Vector CFacility::ECIPos(const CDateTime time)
{
	return ~(ECI_ECF(time))*ECFPosition;
}

//! ݵγȼعϵλ
void CFacility::CalculateECF()
{
	double GeocentricLatitude = atan(tan(Latitude)*(1.0-Oblate)*(1.0-Oblate));

	ECFPosition.x = (Re + Altitude) * cos(GeocentricLatitude) * cos(Longitude);
	ECFPosition.y = (Re + Altitude) * cos(GeocentricLatitude) * sin(Longitude);
	ECFPosition.z = (Re + Altitude) * sin(GeocentricLatitude);
}
